name = 'System utils'


from Prophet.Executable import _Multiname


class bugbuddy (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'Bugbuddy'
		self.comment = 'GNOME bug reporting tool'
		self.keywords = ['standard', 'X11', 'GNOME', 'bug', 'system', 'utility']
		self._executables = ['bug-buddy']


class gnomecc (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME control center'
		self.comment = 'Control center for GNOME'
		self.keywords = ['standard', 'X11', 'GNOME', 'settings']
		self._executables = ['gnomecc']


class gconfeditor (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GConf configurator'
		self.comment = 'Configuration editor for GConf'
		self.keywords = ['standard', 'X11', 'GNOME', 'GConf', 'settings']
		self._executables = ['gconf-editor']


class gdm (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GDM'
		self.comment = 'GNOME display manager'
		self.keywords = ['console', 'standard', 'X11', 'GNOME', 'display', 'manage']
		self._executables = ['gdm']
		self.interactive = 0


class gdmconfig (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GDM configurator'
		self.comment = 'GNOME display manager configuration utility'
		self.keywords = ['standard', 'X11', 'GNOME', 'GDM', 'XDM', 'settings', 'utility']
		self._executables = ['gdmconfig']


class gnomba (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'Gnomba'
		self.comment = 'Network browser for GNOME'
		self.keywords = ['X11', 'GNOME', 'SMB', 'Samba', 'network', 'browse']
		self._executables = ['gnomba']


class gnorpm (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GnoRPM'
		self.comment = 'RPM manager for GNOME'
		self.keywords = ['X11', 'GNOME', 'RPM', 'package', 'manage']
		self._executables = ['gnorpm']


class gsysmonitor (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME system monitor'
		self.comment = 'GNOME top-like monitor'
		self.keywords = ['standard', 'X11', 'GNOME', 'top', 'frontend',
			'utility']
		self._executables = ['gnome-system-monitor']


class gterminal (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME terminal'
		self.comment = 'Terminal emulator for GNOME'
		self.keywords = ['standard', 'X11', 'GNOME', 'terminal', 'emulate']
		self._executables = ['gnome-terminal']


class gtop (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME top'
		self.comment = 'GNOME frontend to top utility'
		self.keywords = ['standard', 'X11', 'GNOME', 'top', 'frontend', 'utility']
		self._executables = ['gtop']


class guname (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME sysinfo'
		self.comment = 'GNOME frontend to uname utility'
		self.keywords = ['standard', 'X11', 'GNOME', 'uname', 'frontend', 'utility']
		self._executables = ['guname']


class gwho (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'GNOME who'
		self.comment = 'GNOME frontend to w utility'
		self.keywords = ['standard', 'X11', 'GNOME', 'w', 'frontend', 'utility']
		self._executables = ['gw'] # FIXME : possible name clash - implement more detailed search
