import Prophet.Package
from Prophet.Program.X.Office import _SOApp
from Prophet.Executable import _Multiname


class oocalc (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OOcalc'
		self.comment = 'OpenOffice spreadsheet'
		self.keywords += ['spreadsheet']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['scalc', 'oocalc']


class oodraw (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OOdraw'
		self.comment = 'OpenOffice vector drawing program'
		self.keywords += ['vector', 'draw', 'image', 'graphics']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['sdraw', 'oodraw']


class ooffice (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OpenOffice'
		self.comment = 'OpenOffice shell'
		self.keywords += ['shell', 'workplace', 'suite']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['soffice', 'ooffice']


class ooimpress (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OOimpress'
		self.comment = 'OpenOffice presentation designer'
		self.keywords += ['graphics', 'multimedia', 'presentation', 'draw', 'design']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['simpress', 'ooimpress']


class oomath (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OOmath'
		self.comment = 'OpenOffice formula editor'
		self.keywords += ['formula', 'edit', 'science']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['smath', 'oomath']


class oowriter (_SOApp):
	def __init__ (self):
		_SOApp.__init__ (self)
		self.name = 'OOwriter'
		self.comment = 'OpenOffice word processor'
		self.keywords += ['text', 'edit', 'word', 'process']
		self._package = Prophet.Package.OpenOffice
		self._executables = ['swriter', 'oowriter']
