name = 'Shells'


from Prophet.Executable import _Multiname
from Prophet.Executable import _Versioned


class dfm (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'DFM'
		self.comment = 'OS/2\'s WPS-like file manager'
		self.keywords = ['X11', 'OS/2', 'explore', 'file', 'manage']
		self._executables = ['dfm']


class expectk (_Versioned):
	def __init__ (self):
		_Versioned.__init__ (self)
		self.name = 'Expect shell'
		self.comment = 'Tcl/Tk based interactive dialogue program, X11 version'
		self.keywords = ['console', 'shell', 'Tcl', 'Tk', 'X11', 'expect', 'control']
		self._basenames = ['expectk']


class filerunner (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'FileRunner'
		self.comment = 'File manager for X'
		self.keywords = ['X11', 'Tk', 'file', 'manage']
		self._executables = ['fr'] # FIXME : possible name clash!


class rox (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'ROX'
		self.comment = 'RISC OS-like file manager, fast and powerful'
		self.keywords = ['X11', 'RISCOS', 'explore', 'file', 'manage']
		self._executables = ['rox']


class tixwish (_Versioned):
	def __init__ (self):
		_Versioned.__init__ (self)
		self.name = 'TixWish'
		self.comment = 'Tk interface extension shell'
		self.keywords = ['Tcl', 'Tk', 'Tix', 'console', 'X11', 'shell']
		self._basenames = ['tixwish']


class tuxcmd (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'TuxCmd'
		self.comment = 'A Windows Commander clone for X'
		self.keywords = ['X11', 'WinCommander', 'NC', 'clone', 'shell', 'file', 'manage']
		self._executables = ['tuxcmd']


class wish (_Versioned):
	def __init__ (self):
		_Versioned.__init__ (self)
		self.name = 'Wish'
		self.comment = 'Tcl/Tk windowing shell'
		self.keywords = ['console', 'Tcl', 'Tk', 'X11', 'shell']
		self._basenames = ['wish']


class wishx (_Versioned):
	def __init__ (self):
		_Versioned.__init__ (self)
		self.name = 'WishX'
		self.comment = 'Extended Tcl/Tk windowing shell'
		self.keywords = ['console', 'TclX', 'TkX', 'Tcl', 'Tk', 'X11', 'shell']
		self._basenames = ['wishx']


class xnc (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'XNC'
		self.comment = 'X Northern Captain - NC clone for X'
		self.keywords = ['X11', 'MC', 'NC', 'clone', 'shell', 'file', 'manage']
		self._executables = ['xnc']


class xplore (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'Xplorer'
		self.comment = 'Motif explorer-like file manager'
		self.keywords = ['X11', 'Motif', 'explore', 'file', 'manage']
		self._executables = ['xplore']


from Prophet.Program.XFce4.XFFM import xffm


from Prophet.Program.XFce import xftree


class xwc (_Multiname):
	def __init__ (self):
		_Multiname.__init__ (self)
		self.name = 'XWinCommander'
		self.comment = 'NC clone for X'
		self.keywords = ['X11', 'MC', 'NC', 'clone', 'shell', 'file', 'manage']
		self._executables = ['xwc']
